//#include "mbed.h"
//#include "config.h"
#include "uart.h"

#define AHBMEM ((void *)0x2007C000)
#define AHBMEMSIZE (16300 * 2)		// ethernetの領域も使う
//#define AHBMEM ((void *)0x20080000)
//#define AHBMEMSIZE 16300

static char *free_ptr = (char *)AHBMEM;
static int free_sz = AHBMEMSIZE;

void reset_ahb_mem(void)
{
   free_ptr = (char *)AHBMEM;
   free_sz = AHBMEMSIZE;
}

void *mad_malloc(unsigned int sz)
{
  unsigned int nsz = ((sz >> 3) + 1) << 3; // align to 8 byte
  if(nsz < free_sz)
  {
    char *p = free_ptr;
	free_ptr += nsz;
	free_sz -=nsz;
	//UARTSendInt(1, "free_sz=", 8, free_sz);
	return(p);
  }
  else
  {
	  return (void *)0;
	  //return(malloc(sz));
  }
}
